unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLTeapot, GLCoordinates, GLCrossPlatform,
  BaseClasses, GLWin32Viewer, GLSkydome, ExtCtrls, StdCtrls, GLGeomObjects,
  GLPolyhedron, GLColor;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLPlane1: TGLPlane;
    GLDummyCube1: TGLDummyCube;
    Button1: TButton;
    Label1: TLabel;
    GLSceneViewer1: TGLSceneViewer;
    GLPolygon1: TGLPolygon;
    Button2: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    px,py     : integer;
    ss        : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ss := GLCamera1.SceneScale;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.01;
  if (ss <= 0.2) then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.01;
  if (ss > 2.5) then ss := 2.5;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(
  Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

// Cinta
// circulo en X-Y
// Crezca en Z
procedure TForm1.Button2Click(Sender: TObject);
var
  x1,x2,y1,y2,
  h,R,phi, dph   : single;
  k,n,neb        : integer;
  tri            : TGLPolygon;
  obj            : TGLBaseSceneObject;
begin
  // quitar los poligonos
  neb := GLScene1.Objects.Count;
  for k := neb-1 downto 0 do begin
    obj := GLScene1.Objects[k];
    if (obj is TGLPolygon) then obj.Free;
  end;

  h := 1;
  R := 1.5;

  n := StrToInt(Edit1.Text);
  phi := 0.0;
  dph := 2*pi/n;

  for k := 0 to n - 1 do begin
    // primer Triangulo
    tri := TGLPolygon.Create(self);
    tri.Material.FrontProperties.Emission.Color := clrBlue;

    x1 := R*cos(phi);
    y1 := R*sin(phi);

    phi := phi + dph;
    x2 := R*cos(phi);
    y2 := R*sin(phi);

    tri.Nodes.AddNode(x1,y1,0);
    tri.Nodes.AddNode(x2,y2,0);
    tri.Nodes.AddNode(x2,y2,h);

    GLScene1.Objects.AddChild(tri);

    // segundo Triangulo
    tri := TGLPolygon.Create(self);
    tri.Material.FrontProperties.Emission.Color := clrRed;

    tri.Nodes.AddNode(x1,y1,h);
    tri.Nodes.AddNode(x1,y1,0);
    tri.Nodes.AddNode(x2,y2,h);

    GLScene1.Objects.AddChild(tri);
  end;
end;


end.
